#!/usr/bin/perl -w

use strict;                        # Strenge Variablenkonventionen
use CGI::Switch;                   # "Umschaltendes" CGI
 
my $efile = 'email.dat';           # Datei mit Adressen
my $q = CGI::Switch->new();        # CGI-Objekt

if(! defined $q->param('email')) { # Keine Email eingetragen (erster 
                                   # Aufruf?) => Einfhrungsseite
    print_form($q, "Bitte tragen Sie Ihre Email-Adresse ein.");

} elsif ($q->param('email') =~ /\S\@.+?\..+/) {
                                   # Gltige Email => speichern.
                      # Datei erzeugen, falls noch nicht vorhanden
    do {open(FILE, ">$efile"); close(FILE)} unless -f $efile;

                      # Read/Write ffnen.
    open(FILE, "+<$efile") || error($q, "Cannot open file $efile");

    flock(FILE, 2);   # Gegen parallele Zugriffe sichern
    seek(FILE, 0, 0); # An den Dateianfang manvrieren

    while(<FILE>) {   # Datei nach neuer Email durchsuchen
        chop;
        if($_ eq $q->param('email')) {
            print_form($q, "Sie sind bereits registriert. Vielen Dank.");
            close(FILE);
            return 0;
        } 
    }
        
    seek(FILE, 0, 2); # Ans Dateiende seeken und email anhngen
    print FILE $q->param('email'), "\n";
    close(FILE);
    
    print_form($q, "Registrierung erfolgreich. Vielen Dank.");

} else {
    # Unsinn eingetragen, mit Fehlermeldung wiederholen.
    print_form($q, "Ungltige Email-Adresse - bitte nochmal.");
}


sub print_form {
#######################################
# Formular mit Nachrichtentext ausgeben
#######################################
    my ($q, $message) = @_;

    print $q->header,
          $q->start_html(-title => "Registration"),
          $q->h2($message), $q->start_form, $q->p("Email:"),
          $q->textfield(-name => 'email', 
                        -value => ($q->param('email') || "")),
          $q->submit(-value => "Registrieren"), $q->end_form;
}

sub error {
##############################################
# Fatalen Fehler ausgeben und Programm beenden
##############################################
    my $q = shift;
    print $q->header, "<H2>Fatal error:</H2> <H1>@_</H1>\n";
    exit 0;
}
